package com.danmassey.rugbe.board;

/**
 * @author dmassey
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Node implements Comparable {
	private int x;
	private int y;
	private int g;
	private int h;
	private int f;
	private int d;
	private char terrain;
	private Node parent;
	private Node child;
	private Node temp;
		
	public Node(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public Node(int x, int y, char terrain) {
		this(x, y);
		this.terrain = terrain;
	}
	
	public int getX() {
		return this.x;
	}
	
	public int getY() {
		return this.y;
	}
	
	public void setG(int g) {
		this.g = g;
	}
	
	public int getG() {
		return this.g;
	}
	
	public void setH(int h) {
		this.h = h;
	}
	
	public int getH() {
		return this.h;
	}
	
	public void setF(int f) {
		this.f = f;
	}
	
	public int getF() {
		return this.f;
	}
	
	public void setDistance(int distance) {
		this.d = distance;
	}
		
	public int getDistance() {
		return this.d;
	}	
	
	public void setParent(Node parent) {
		this.parent = parent;
	}
	
	public Node getParent() {
		return this.parent;
	}
	
	public void setChild(Node child) {
		this.child = child;
	}
	
	public Node getChild() {
		return this.child;
	}
	
	public char getTerrain() {
		return terrain;
	}
	
	public int distance(Node n) {
		int distX = Math.abs(n.x - this.x);
		int distY = Math.abs(n.y - this.y);
		return distX + distY;		
	}
	
	public int distance(Pkg p) {
		int distX = Math.abs(p.getDestX() - this.x);
		int distY = Math.abs(p.getDestY() - this.y);
		return distX + distY;
	}
	
	public boolean sameNode(Node n) {
		if ((n.x == this.x) && (n.y == this.y)) {
			return true;
		}
		return false;	
	}
	
	// f sorting comparison
	public boolean equals(Object o) {
		if (o instanceof Node) {
			Node n = (Node) o;
			if ((n.x == this.x) && (n.y == this.y)) {
				this.temp = n;
				return true;
			}
		}
		return false;
	}
	
	public Node getTemp() {
		return this.temp;
	}
	
	public void clearTemp() {
		this.temp = null;
	}
	
	/**
	 * @see java.lang.Comparable#compareTo(Object)
	 */
	public int compareTo(Object o) {
		Node n = (Node) o;
		int dif = this.f - n.f;
		if (dif == 0) {
			if (this.equals(n)) {
				return 0;
			} else {
				return -1;
			}
		} else {
			return dif;
		}
	}

	public String toString() {
		StringBuffer buffy = new StringBuffer();
		buffy.append("Node: ");
		buffy.append(x);
		buffy.append(" ");
		buffy.append(y);
		buffy.append(" ");
		buffy.append(f);
		return buffy.toString();
	}
}
