package com.danmassey.rugbe.brain;

import java.util.LinkedHashMap;
import java.util.ResourceBundle;

import com.danmassey.rugbe.board.Board;
import com.danmassey.rugbe.interpreter.ResponseInterpreter;
import com.danmassey.rugbe.net.ComChannel;
import com.danmassey.rugbe.robot.Robot;
import com.danmassey.rugbe.ui.DebugUI;

/**
 * 
 * 
 * @author dan
 * Created on Aug 30, 2002
 **/
public class BrainFactory {
	private static final String PROP_PATH = "com.danmassey.rugbe.properties.";
	private static final String DEFAULT_BRAIN = "brainConfig";
	
	/**
	 * Method makeBrain.
	 * @param robot
	 * @param board
	 * @param nbots
	 * @param com
	 */
	public static IBrain makeBrain(String brainConfig, Robot robot, Board board, 
			LinkedHashMap nbots, ComChannel com, DebugUI ui) {
				
		if ((brainConfig == null) || ("".equals(brainConfig))) {
			brainConfig = DEFAULT_BRAIN;
		}
				
		ResourceBundle bundle = ResourceBundle.getBundle(PROP_PATH + brainConfig);
		String brainClassName = bundle.getString("brain");
		IBrain brain;
		try {
			Class brainClass = Class.forName(brainClassName);
			brain = (IBrain) brainClass.newInstance();
			brain.init(robot, board, nbots, com, bundle, ui);
			return brain;
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
		return null;	
	}

}
