package com.danmassey.rugbe.parsers;

import java.util.LinkedHashSet;

import com.danmassey.rugbe.board.Board;
import com.danmassey.rugbe.board.Pkg;
import com.danmassey.rugbe.net.ComChannel;
import com.danmassey.rugbe.robot.Robot;

/**
 * 
 * 
 * @author dan
 * Created on Aug 30, 2002
 **/
public class ProtocolParser {
	PackageParser packageParser = new PackageParser();
	
	/**
	 * Method parseBoard.
	 * @param com
	 * @return Board
	 **/
	public Board parseBoard(ComChannel com) {
		BoardParser bp = new BoardParser(com);
		Board board = bp.parse();
		return board;
	}

	/**
	 * Method parseRobot.
	 * @param com
	 * @return Robot
	 **/
	public Robot parseRobot(ComChannel com) {
		RobotParser rp = new RobotParser(com);
		Robot robot = rp.parse();
		return robot;
	}
	
	/**
	 * Method parsePackages.
	 * @param com
	 * @return Package[]
	 **/
	public Pkg[] parsePackages(ComChannel com) {
		Pkg[] packages = this.packageParser.parse(com);
		return packages;
	}
}
