package com.danmassey.rugbe.robot;

/**
 * Represents other bots in the world
 * 
 * @author dan
 * Created on Aug 30, 2002
 **/
public class NBot {
	private int id;
	private int x;
	private int y;
	private int distance;
	private boolean me;
	private boolean updated;
	private int packages;
	
	public NBot(int id, int x, int y, boolean me) {
		this.id = id;
		this.x = x;
		this.y = y;
		this.me = me;
		this.updated = false;
		packages = 0;
	}

	public boolean isMe() {
		return this.me;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getX() {
		return this.x;
	}
	
	public void setY(int y) {
		this.y = y;
	}

	public int getY() {
		return this.y;
	}
	
	public int getPackageCount() {
		return packages;
	}
	
	public int getId() {
		return this.id;
	}
	
	public boolean isUpdated() {
		return this.updated;
	}
	
	public void setUpdated(boolean updated) {
		this.updated = updated;
	}
	
	public int calcDistance(int x, int y) {
		int distX = x - this.x;
		int distY = y - this.y;
		this.distance = Math.abs(distX + distY);
		return this.distance;
	}
	
	public int getDistance() {
		return this.distance;
	}
	
	public void pickUp() {
		packages++;
	}
	
	public void drop() {
		packages--;
	}
	
	public void moveNorth() {
		this.y += 1;
	}

	public void moveEast() {
		this.x += 1;
	}

	public void moveSouth() {
		this.y -= 1;
	}

	public void moveWest() {
		this.x -= 1;
	}
}
